/**
 * @copyright   2016-2019, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 */

// Our index re-exports TypeScript types, which Babel is unable to detect and omit.
// Because of this, Webpack and other bundlers attempt to import values that do not exist.
// To mitigate this issue, we need this module specific index file that manually exports.

import Interweave from './esm/Interweave';
import Markup from './esm/Markup';
import Filter from './esm/Filter';
import Matcher from './esm/Matcher';

export { Markup, Filter, Matcher };

export default Interweave;
